/* Fab Academy Karaoke machine
 *  David McCallum, Xavier Klein, Dima Paley, 2018
 *  sintheta.org
 *  Code adapted from http://aconcaguasci.blogspot.nl/2016/11/arduino-cnc-shield-control-stepper.html
 *
 * For both X and Y, 50 steps per cm 
 * 
 * 
  *//



// Motor stuff
const int ENABLE = 8 ;

const int  motorX_DIR   =  5;  //Direction pin
const int  motorX_STP    = 2;  //Step pin

const int  motorY_DIR   =  7;  //Direction pin
const int  motorY_STP   = 4;  //Step pin

const int endstopPinX = 9;

//Driver Timing
int delayTime=450; //Delay between each pause (uS)

int musicPulse = 300;     // music timing pulse for the frere jacques functions



void setup(){

//  serial.begin(9600);

  pinMode(motorX_DIR, OUTPUT); pinMode(motorX_STP, OUTPUT);
  pinMode(motorY_DIR, OUTPUT); pinMode(motorY_STP, OUTPUT);
  
  pinMode(ENABLE, OUTPUT);
  digitalWrite(ENABLE, LOW);
  
  pinMode(endstopPinX, INPUT_PULLUP);



  goHome();         // zero the motor to the edge

  delay(2000);      // pause
  
  frBackwards() ;   // Play the song


  
}

void loop(){

}



// The basic move function
void step(boolean dir, byte dirPin, byte stepperPin, int steps){

  digitalWrite(dirPin, dir);

  for (int i = 0; i < steps; i++) {
    digitalWrite(stepperPin, HIGH);
    delayMicroseconds(delayTime); 
    digitalWrite(stepperPin, LOW);
    delayMicroseconds(delayTime); 
  }
}



// Move the motor until the endstop is reached
void goHome() {

  while (digitalRead(endstopPinX) == HIGH) {            // if the button isn't pressed, move the motor 1 step
    step(false, motorX_DIR, motorX_STP, 1);
    delayMicroseconds(delayTime);
  }
  
  step(true, motorX_DIR, motorX_STP, 50);
  
}



// play Frere Jacques with alternating lines moving backwards (because the motor couldn't rewind fast enough)

void frBackwards() {
 
  step(true, motorX_DIR, motorX_STP, 185);
  delay(musicPulse);

  for (int x = 0; x < 2 ; x++) {
    step(true, motorX_DIR, motorX_STP, 215);
    delay(musicPulse);
    step(true, motorX_DIR, motorX_STP, 220);
    delay(musicPulse);
    step(true, motorX_DIR, motorX_STP, 220);
    delay(musicPulse);
  
    step(true, motorY_DIR, motorY_STP, 150);
    delay(musicPulse);
  
  
    step(false, motorX_DIR, motorX_STP, 220);
    delay(musicPulse);
    step(false, motorX_DIR, motorX_STP, 220);
    delay(musicPulse);
    step(false, motorX_DIR, motorX_STP, 215);
    delay(musicPulse);
  
    step(true, motorY_DIR, motorY_STP, 150);
    delay(musicPulse);

  }



 
  



  
}


// Try Frere Jacques forwards for 4 lines
void fourLinesFR() {

 
  for (int x = 0; x < 4; x++) {
  
  step(true, motorX_DIR, motorX_STP, 185);
  delay(musicPulse);
  step(true, motorX_DIR, motorX_STP, 215);
  delay(musicPulse);
  step(true, motorX_DIR, motorX_STP, 220);
  delay(musicPulse);
  step(true, motorX_DIR, motorX_STP, 220);


  step(true, motorY_DIR, motorY_STP, 150);
  
  step(false, motorX_DIR, motorX_STP, 935);

  }



}


